<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProductInterfaceResult_v2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfProductInterfaceResult_v2 extends AbstractStructArrayBase
{
    /**
     * The ProductInterfaceResult_v2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProductInterfaceResult_v2[]
     */
    public $ProductInterfaceResult_v2;
    /**
     * Constructor method for ArrayOfProductInterfaceResult_v2
     * @uses ArrayOfProductInterfaceResult_v2::setProductInterfaceResult_v2()
     * @param \StructType\ProductInterfaceResult_v2[] $productInterfaceResult_v2
     */
    public function __construct(array $productInterfaceResult_v2 = array())
    {
        $this
            ->setProductInterfaceResult_v2($productInterfaceResult_v2);
    }
    /**
     * Get ProductInterfaceResult_v2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProductInterfaceResult_v2[]|null
     */
    public function getProductInterfaceResult_v2()
    {
        return isset($this->ProductInterfaceResult_v2) ? $this->ProductInterfaceResult_v2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProductInterfaceResult_v2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProductInterfaceResult_v2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProductInterfaceResult_v2ForArrayConstraintsFromSetProductInterfaceResult_v2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProductInterfaceResult_v2ProductInterfaceResult_v2Item) {
            // validation for constraint: itemType
            if (!$arrayOfProductInterfaceResult_v2ProductInterfaceResult_v2Item instanceof \StructType\ProductInterfaceResult_v2) {
                $invalidValues[] = is_object($arrayOfProductInterfaceResult_v2ProductInterfaceResult_v2Item) ? get_class($arrayOfProductInterfaceResult_v2ProductInterfaceResult_v2Item) : sprintf('%s(%s)', gettype($arrayOfProductInterfaceResult_v2ProductInterfaceResult_v2Item), var_export($arrayOfProductInterfaceResult_v2ProductInterfaceResult_v2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ProductInterfaceResult_v2 property can only contain items of type \StructType\ProductInterfaceResult_v2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ProductInterfaceResult_v2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProductInterfaceResult_v2[] $productInterfaceResult_v2
     * @return \ArrayType\ArrayOfProductInterfaceResult_v2
     */
    public function setProductInterfaceResult_v2(array $productInterfaceResult_v2 = array())
    {
        // validation for constraint: array
        if ('' !== ($productInterfaceResult_v2ArrayErrorMessage = self::validateProductInterfaceResult_v2ForArrayConstraintsFromSetProductInterfaceResult_v2($productInterfaceResult_v2))) {
            throw new \InvalidArgumentException($productInterfaceResult_v2ArrayErrorMessage, __LINE__);
        }
        if (is_null($productInterfaceResult_v2) || (is_array($productInterfaceResult_v2) && empty($productInterfaceResult_v2))) {
            unset($this->ProductInterfaceResult_v2);
        } else {
            $this->ProductInterfaceResult_v2 = $productInterfaceResult_v2;
        }
        return $this;
    }
    /**
     * Add item to ProductInterfaceResult_v2 value
     * @throws \InvalidArgumentException
     * @param \StructType\ProductInterfaceResult_v2 $item
     * @return \ArrayType\ArrayOfProductInterfaceResult_v2
     */
    public function addToProductInterfaceResult_v2(\StructType\ProductInterfaceResult_v2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProductInterfaceResult_v2) {
            throw new \InvalidArgumentException(sprintf('The ProductInterfaceResult_v2 property can only contain items of type \StructType\ProductInterfaceResult_v2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ProductInterfaceResult_v2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProductInterfaceResult_v2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProductInterfaceResult_v2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProductInterfaceResult_v2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProductInterfaceResult_v2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProductInterfaceResult_v2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProductInterfaceResult_v2
     */
    public function getAttributeName()
    {
        return 'ProductInterfaceResult_v2';
    }
}
